/*
  vt1xx terminal emulation by
  Rene Rebe <rene@exactcode.de>
  
  Lossy based on code of bogl-term by:
  Edmund GRIMLEY EVANS <edmundo@rano.org>
  
  Additional information from the Linux kernel driver/char/vt.c by:
  Linus Torvalds
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA. */


#include "Term.hh"

//#include "X11Helper.hh"
#include "EvasHelper.hh"

class eTerm : public Term
{
public:
  
  eTerm (EvasCanvas* _evas, int _xsize, int _ysize);
  
  int Width () { return fw*xsize; }
  int Height () { return fh*ysize; }

  int FontWidth () { return fw; }
  int FontHeight () { return fh; }
  
  // don't do this often - it is a resource hog
  void Resize (int _xsize, int _ysize);
  
protected:
  virtual void put_char (int x, int y, wchar_t wc,
			 int fg, int bg, int ul);
  
private:
  EvasCanvas* evas;
  
  // font width height
  int fw, fh;
  
  // I know this is rediculous, I wanted something working quickly - to be optimized :-!
  EvasText** escreen;
  EvasRectangle** escreen_back;
};
